Foreman - Bug #15213

DHCP conflict detection fails with exception if proxy is unavailable
05/27/2016 10:21 AM - Marek Hulan

Status: Closed
Priority: Normal
Assignee: Marek Hulan
Category: DHCP
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: No Found in Releases:
Bugzilla link: 1337462 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3554
Description

Cloned from https://bugzilla.redhat.com/show_bug.cqi?id=1337462

Description of problem:

Following exception raised in production.log while performing "yum update”

to update packages from sat6.1.9 -> Sat6.2 snap12. Though the log-level seems "warning" but following exception is being logged in
production.log

==> /var/log/foreman/production.log <==
2016-05-19 04:32:23 [app] [W] failed to detect boot server: ERF12-5139 [ProxyAPI::ProxyException]:
Unable to detect TFTP boot server ([Errno::ECONNREFUSED]: Connection refused - connect (2) for "ge
-sat6-upgrade-rhel7.satqge.lab.eng.rdu2.redhat.co...) for Capsule https://ge-sat6-upgrade-rhel7.sat
ge.lab.eng.rdu2.redhat.com:9090/tftp
| ProxyAPI::ProxyException: ERF12-5139 [ProxyAPI::ProxyException]: Unable to detect TFTP boot ser
ver ([Errno::ECONNREFUSED]: Connection refused - connect (2) for "ge-sat6-upgrade-rhel7.satqge.lab.e
ng.rdu2.redhat.co...) for Capsule https://ge-sat6-upgrade-rhel7.satge.lab.eng.rdu2.redhat.com:9090
/tftp
| /usr/share/foreman/lib/proxy_api/tftp.rb:49:in "rescue in bootServer'
/usr/share/foreman/lib/proxy_api/tftp.rb:42:in "bootServer'
/usr/share/foreman/app/models/concerns/orchestration/dhcp.rb:72:in “boot_server'
/usr/share/foreman/app/models/concerns/orchestration/dhcp.rb:99:in “~dhcp_attrs'
/usr/share/foreman/app/models/concerns/orchestration/dhcp.rb:20:in "~ dhcp_record'
/usr/share/foreman/app/models/concerns/orchestration/dhcp.rb:179:in “dhcp_conflict_detected?'
/opt/rh/rh-ror4l/root/usr/share/gems/gems/activesupport-4.1.5/1ib/active_support/callbacks.rb:4

\

\

\

\

\

\

24:in "block in make_lambda'

| /opt/rh/rh-rord4l/root/usr/share/gems/gems/activesupport-4.1.5/1lib/active_support/callbacks.rb:2
1

31:in “call’

| /opt/rh/rh-rord4l/root/usr/share/gems/gems/activesupport—-4.1.5/1lib/active_support/callbacks.rb:2
3l:in "block in halting’
Version-Release number of selected component (if applicable):
Sat[6.1.9 -> 6.2 snap12]
How reproducible:
Steps to Reproduce:
1. set sat6.2 repo
2. katello-service stop
3. yum update -y

Actual results:

Expected results:
No such exception in logs. If its a real issue then we need to fix it otherwise, we should suppress the exception, if possible.

Additional info:
Related issues:
Related to Foreman - Tracker #14002: Orchestration build around ActiveRecord ... New 03/02/2016
Related to Foreman - Feature #10782: Add global status for hosts Closed 06/11/2015

Associated revisions

Revision 801c2fec - 05/31/2016 09:38 AM - Marek Hulan

Fixes #15213 - handle host update when proxy is unreachable

History

#1 - 05/27/2016 10:24 AM - Dominic Cleal

- Subject changed from Upgrade [6.1.9 -> 6.2 snap12] failed to detect boot server: ERF12-5139 [ProxyAPI::ProxyException] to Upgrade failed to
detect boot server: ERF12-5139 [ProxyAPI::ProxyException]

- Description updated

The log is missing context about what was happening (a request?), can you put any more info into this bug report please?

#2 - 05/27/2016 10:31 AM - Marek Hulan

- Subject changed from Upgrade failed to detect boot server: ERF12-5139 [ProxyAPI::ProxyException] to DHCP conflict detection fails with exception
if proxy is unavailable

- Category set to DHCP

The root cause is that whenever existing host is saved (updated) we check for DHCP conflicts through proxy. If the communication with proxy fails,
the check fails with exception. | think we should ignore such errors when proxy is unreachable and user wants to change e.g. only the host's comment
attribute. Until we have better orchestration not driven by active record callbacks...

#3 - 05/27/2016 10:31 AM - Marek Hulan

- Status changed from New to Assigned

#4 - 05/27/2016 10:33 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3554 added

#5 - 05/27/2016 10:39 AM - Marek Hulan

To reproduce: turn off DHCP proxy and try following from console Host.last.update :comment => 'test'. If the last host is managed and has the proxy
set correctly, it will fail with exception.

#6 - 05/27/2016 10:45 AM - Marek Hulan
- Related to Tracker #14002: Orchestration build around ActiveRecord hooks tracker added

#7 - 05/30/2016 05:10 AM - Marek Hulan

Unfortunately there's no easy way to disable the orchestration. The original motivation to fix this was host statuses migration so | fixed that instead so
it skips validation. That should not do any harm, since we are not modifying any data, just creating sub-statuses and updating global status
respectively.

#8 - 05/30/2016 08:12 AM - Marek Hulan
- Related to Feature #10782: Add global status for hosts added

#9 - 05/31/2016 10:02 AM - Marek Hulan
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 801c2fecd8762f6f04c9f855d318d7eaff36f16c¢.

#10 - 06/01/2016 03:46 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#11 - 02/23/2023 04:08 PM - James lernard
- Triaged set to No
